

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Dealing with time &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script src="../../../_static/js/bootstrap.min.js"></script>
        <script src="../../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
    <link rel="next" title="What is a time series?" href="time_series.html" />
    <link rel="prev" title="Concepts" href="../concepts.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../installation.html">Installation</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../concepts.html">Concepts</a><ul class="current">
<li class="toctree-l2 current"><a class="current reference internal" href="#">Dealing with time</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#utc-gmt-and-dst">UTC / GMT and DST</a></li>
<li class="toctree-l3"><a class="reference internal" href="#epoch-timestamp">Epoch Timestamp</a></li>
<li class="toctree-l3"><a class="reference internal" href="#python-datetime-vs-epoch">Python datetime vs. epoch</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="time_series.html">What is a time series?</a></li>
<li class="toctree-l2"><a class="reference internal" href="expressions.html">Time series expressions</a></li>
<li class="toctree-l2"><a class="reference internal" href="dts.html">DTSS - Distributed Time Series System</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../concepts.html">Concepts</a> &raquo;</li>
        
      <li>Dealing with time</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../../_sources/content/time_series/concepts/time.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="dealing-with-time">
<span id="concepttime"></span><h1>Dealing with time<a class="headerlink" href="#dealing-with-time" title="Permalink to this headline">¶</a></h1>
<div class="section" id="utc-gmt-and-dst">
<h2>UTC / GMT and DST<a class="headerlink" href="#utc-gmt-and-dst" title="Permalink to this headline">¶</a></h2>
<p><a class="reference external" href="https://en.wikipedia.org/wiki/Coordinated_Universal_Time">Coordinated Universal Time (UTC)</a>
was introduced as the more accurate replacement of
<a class="reference external" href="https://en.wikipedia.org/wiki/Greenwich_Mean_Time">Greenwich Mean Time (GMT)</a>.
In 1963, the concept of UTC was established as the primary international
standard which would denote how other countries would regulate their time in
relation to UTC.</p>
<p>The primary reason why UTC was considered to be a more accurate system was the
fact that it used the rotation of Earth and atomic clocks for measurements.
Moreover, to maintain the consistent time system, UTC does not observe
<a class="reference external" href="https://en.wikipedia.org/wiki/Daylight_saving_time">Daylight Saving Time (DST)</a>,
the shifting of time by an hour in summer and winter so that darkness falls at a
later clock time.</p>
<p>Although GMT and UTC share the same current time in practice, there is a basic
difference between the two:</p>
<blockquote>
<div><ol class="arabic simple">
<li><p>GMT is a time zone officially used in some European and African countries.</p></li>
<li><p>UTC is not a time zone, but a time standard that is the basis for civil
time and time zones worldwide. This means that no country or territory
officially uses UTC as a local time.</p></li>
</ol>
</div></blockquote>
<p>Neither UTC nor GMT ever change for Daylight Saving Time (DST). However, some of
the countries that use GMT switch to different time zones during their DST
period. For example, the United Kingdom is not on GMT all year, it uses British
Summer Time (BST), which is one hour ahead of GMT, during the summer months.</p>
<p><strong>UTC represents absolute time and therefore should be used for all program internal date/time representations.</strong></p>
<p>For more information, please check <a class="reference external" href="https://en.wikipedia.org/wiki/Coordinated_Universal_Time">Wikipedia - Coordinated Universal Time</a>.</p>
</div>
<div class="section" id="epoch-timestamp">
<h2>Epoch Timestamp<a class="headerlink" href="#epoch-timestamp" title="Permalink to this headline">¶</a></h2>
<p>Date and time are very difficult to deal with correctly. Instead of using a
datetime object, it is easier to use Unix time (also known as Epoch time, POSIX
time, seconds since the Epoch or UNIX Epoch time) which is represented as a
simple integer.</p>
<p>The Epoch timestamp is the number of seconds that have elapsed since the
Unix epoch, minus leap seconds. The Unix epoch is 1970-01-01 00:00:00.0 UTC.</p>
<p><strong>Within Shyft, time is represented as number, with fixed digits expressed down to microseconds.</strong></p>
<p>For more information, please check <a class="reference external" href="https://en.wikipedia.org/wiki/Epoch_(computing)">Wikipedia - Epoch (computing)</a>.</p>
</div>
<div class="section" id="python-datetime-vs-epoch">
<h2>Python datetime vs. epoch<a class="headerlink" href="#python-datetime-vs-epoch" title="Permalink to this headline">¶</a></h2>
<p>The following example outlines the issues when dealing with Python native datetime objects.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="c1"># -*- coding: utf-8 -*-</span>
<span class="sd">&quot;&quot;&quot;</span>
<span class="sd">This script contains an example showing the complexity of correctly handling</span>
<span class="sd">timezone and UTC using Python datetime objects.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span> <span class="nn">datetime</span> <span class="kn">import</span> <span class="n">datetime</span>

<span class="kn">from</span> <span class="nn">pytz</span> <span class="kn">import</span> <span class="n">utc</span><span class="p">,</span> <span class="n">timezone</span>

<span class="c1"># Express this point in time in Python datetime</span>
<span class="c1"># Most often, users leave out the time zone information, which is ambiguous.</span>
<span class="n">my_day</span> <span class="o">=</span> <span class="n">datetime</span><span class="p">(</span><span class="mi">2018</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="mi">15</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">my_day</span><span class="p">)</span><span class="si">}</span><span class="s2">       is tz unaware, but is assumed to be your local computer tz!&quot;</span><span class="p">)</span>
<span class="c1"># this is converted to the UTC based epoch timestamp</span>
<span class="n">my_day_ts</span> <span class="o">=</span> <span class="n">my_day</span><span class="o">.</span><span class="n">timestamp</span><span class="p">()</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">my_day</span><span class="p">)</span><span class="si">}</span><span class="s2">       in your local computer tz as UTC epoch timestamp: </span><span class="si">{</span><span class="n">my_day_ts</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>

<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;===================&quot;</span><span class="p">)</span>
<span class="c1"># EXAMPLE: Convert timestamp back to datetime</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;WARNING: The reverse operation also depends on your local computer tz!&quot;</span><span class="p">)</span>
<span class="c1"># convert into tz unaware object, but UTC values</span>
<span class="n">a</span> <span class="o">=</span> <span class="n">datetime</span><span class="o">.</span><span class="n">fromtimestamp</span><span class="p">(</span><span class="n">my_day_ts</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;datetime.fromtimestamp(a)       : </span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">a</span><span class="p">)</span><span class="si">}</span><span class="s2"> (in local computer TZ value)&quot;</span><span class="p">)</span>
<span class="n">b</span> <span class="o">=</span> <span class="n">datetime</span><span class="o">.</span><span class="n">utcfromtimestamp</span><span class="p">(</span><span class="n">my_day_ts</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;datetime.utcfromtimestamp(a)    : </span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">b</span><span class="p">)</span><span class="si">}</span><span class="s2"> (UTC converted from local computer TZ)&quot;</span><span class="p">)</span>
<span class="n">c</span> <span class="o">=</span> <span class="n">datetime</span><span class="o">.</span><span class="n">fromtimestamp</span><span class="p">(</span><span class="n">my_day_ts</span><span class="p">,</span> <span class="n">utc</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;datetime.fromtimestamp(a, utc)  : </span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">c</span><span class="p">)</span><span class="si">}</span><span class="s2"> (UTC converted from local computer TZ)&quot;</span><span class="p">)</span>
<span class="n">d</span> <span class="o">=</span> <span class="n">datetime</span><span class="o">.</span><span class="n">fromtimestamp</span><span class="p">(</span><span class="n">my_day_ts</span><span class="p">,</span> <span class="n">timezone</span><span class="p">(</span><span class="s2">&quot;America/La_Paz&quot;</span><span class="p">))</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;datetime.fromtimestamp(a, LaPaz): </span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">d</span><span class="p">)</span><span class="si">}</span><span class="s2"> (La Paz converted value, relative to local computer TZ)&quot;</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;WARNING: The timestamp again depends on your local computer tz, if no timezone is defined!&quot;</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">a</span><span class="p">)</span><span class="si">}</span><span class="s2">       as UTC epoch timestamp: </span><span class="si">{</span><span class="n">a</span><span class="o">.</span><span class="n">timestamp</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">b</span><span class="p">)</span><span class="si">}</span><span class="s2">       as UTC epoch timestamp: </span><span class="si">{</span><span class="n">b</span><span class="o">.</span><span class="n">timestamp</span><span class="p">()</span><span class="si">}</span><span class="s2"> (!!!!)&quot;</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">c</span><span class="p">)</span><span class="si">}</span><span class="s2"> as UTC epoch timestamp: </span><span class="si">{</span><span class="n">c</span><span class="o">.</span><span class="n">timestamp</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">d</span><span class="p">)</span><span class="si">}</span><span class="s2"> as UTC epoch timestamp: </span><span class="si">{</span><span class="n">d</span><span class="o">.</span><span class="n">timestamp</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>

<span class="c1"># PITFALL:</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;===================&quot;</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;WARNING: Setting a time zone on an unaware datetime object does not convert!&quot;</span><span class="p">)</span>
<span class="n">my_day_utc</span> <span class="o">=</span> <span class="n">utc</span><span class="o">.</span><span class="n">localize</span><span class="p">(</span><span class="n">my_day</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">my_day_utc</span><span class="p">)</span><span class="si">}</span><span class="s2"> the day set as UTC time zone (NOT a conversion!)&quot;</span><span class="p">)</span>
<span class="n">my_day_utc_ts</span> <span class="o">=</span> <span class="n">my_day_utc</span><span class="o">.</span><span class="n">timestamp</span><span class="p">()</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">my_day_utc</span><span class="p">)</span><span class="si">}</span><span class="s2"> as epoch timestamp: </span><span class="si">{</span><span class="n">my_day_utc_ts</span><span class="si">}</span><span class="s2"> (!!!!)&quot;</span><span class="p">)</span>

<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;===================&quot;</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;The epoch time stamp uniquely identifies a point in time!&quot;</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Python datetime objects must be time zone aware to do the same and is cumbersome.&quot;</span><span class="p">)</span>
</pre></div>
</div>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>When DST is applied ins Europe/Oslo, we either move an hour in March from 02:00 to 03:00, missing the hour 02:00
and in October we go back at 03:00 to 02:00, leading to 03:00 happening again an hour later.
So, 03:00 in October DST change leads to two exactly identical datetime objects! This
cannot be represented correctly with lists of datetime objects!</p>
</div>
<p><strong>Shyft uses UTC epoch timestamps internally exclusively, and provides an intelligent</strong> <a class="reference internal" href="../getting_started/calendar.html#usagecalendar"><span class="std std-ref">Calendar</span></a> <strong>avoiding this issue.</strong></p>
<p>For more information, please check <a class="reference external" href="https://en.wikipedia.org/wiki/Daylight_saving_time">Wikipedia - Daylight saving time</a>.</p>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="time_series.html" class="btn btn-neutral float-right" title="What is a time series?" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="../concepts.html" class="btn btn-neutral float-left" title="Concepts" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>